require 'rails/generators/migration'

module NonGrata
    module Generators
        class RolesGenerator < ::Rails::Generators::Base
            include Rails::Generators::Migration
            source_root File.expand_path('../templates', __FILE__)
            desc "Generates roles and roles_privileges tables that are used for databased backed authorization."

            def self.next_migration_number(path)
                unless @prev_migration_nr
                    @prev_migration_nr = Time.now.utc.strftime("%Y%m%d%H%M%S").to_i
                else
                    @prev_migration_nr += 1
                end
                @prev_migration_nr.to_s
            end

            def copy_migrations
                migration_template "non_grata_create_roles_migration.rb", "db/migrate/create_non_grata_authorization_roles_table.rb"
            end
        end
    end
end
