require 'rails/generators/migration'

module NonGrata
    module Generators
        class UserGenerator < ::Rails::Generators::NamedBase 
            include Rails::Generators::Migration
            source_root File.expand_path('../templates', __FILE__)
            desc "generate migration for roles to user record"

            def self.next_migration_number(path)
                unless @prev_migration_nr
                    @prev_migration_nr = Time.now.utc.strftime("%Y%m%d%H%M%S").to_i
                else
                    @prev_migration_nr += 1
                end
                @prev_migration_nr.to_s
            end

            def copy_migrations
                migration_template "non_grata_user_migration.rb", "db/migrate/add_roles_to_#{name.pluralize}.rb"
            end
        end
    end
end
