module NonGrata
    class Authorization
        def self.create(&block) 
            @schemes = [Scheme.new(:main)] 
            instance_eval(&block)
        end

        def self.privilege(resource, action) 
            schemes.first.privileges << Privilege.new(resource, action)
        end

        def self.role(name,&block)
            main_scheme.role(name, &block)
        end

        def self.privileges
            main_scheme.privileges
        end

        ###
        # returns either an array of all schemes or returns 
        # a specific scheme by name
        # Ex:
        # Authorization.schemes   <- returns array of all schemes
        # Authorization.schemes(:main) <- returns the scheme named 'main'
        def self.schemes(name = nil)
            name = name if name.is_a? Symbol
            name = name.to_sym if name.is_a? String

            @schemes ||= [Scheme.new(:main, options)]
            return @schemes if name.nil?
            return schemes.find{|i| i.name == name}
        end

        def self.roles(role_name=nil)
            main_scheme.roles(role_name)
        end

        def self.scheme(name, options=nil, &block)
            scheme = Scheme.new(name, options)
            if block_given?
                scheme.config(&block)
            end
            schemes << scheme
        end
        
        def self.method_missing(sym, *args, &block) 
            return schemes.find{|i| i.name = sym.to_s.sub('_scheme','')} if sym.to_s =~ /[a-z]+_scheme/
            # raise Error  "#{sym} #{args.inspect}"
        end
    end
end
