module NonGrata
    module Tenant

        def create_role(attributes) 
            attributes[:tenant_id] ||= self.id
            attributes[:tenant_type] ||= self.class.name
            attributes[:scheme_name] ||= self.authorization_scheme
            role = NonGrata::AuthorizationRole.create(attributes)
        end    

        def roles
            NonGrata::AuthorizationRole.where(tenant_id: self.id, tenant_type: self.class.name)
        end

        def destroy_role(name)
            role = NonGrata::AuthorizationRole.find_by(
                name: name, 
                scheme_name: authorization_scheme.to_s, 
                tenant_id: self.id, tenant_type: self.class.name)
            role.destroy if role
        end

        def authorization_roles
            NonGrata:AuthorizationRole.where(tenant_id: self.id, tenant_type: self.class.name)
        end

        def authorization_scheme 
            :main
        end

    end
end
